Index: usr.bin/xlint/lint1/err.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/err.c,v
retrieving revision 1.6
diff -u -r1.6 err.c
--- usr.bin/xlint/lint1/err.c	7 Jul 2004 12:13:26 -0000	1.6
+++ usr.bin/xlint/lint1/err.c	25 Dec 2006 10:04:48 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: err.c,v 1.26 2006/06/02 17:38:59 cloder Exp $	*/
 /*	$NetBSD: err.c,v 1.8 1995/10/02 17:37:00 jpo Exp $	*/
 
 /*
@@ -30,7 +31,6 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
- * $NetBSD: err.c,v 1.8 1995/10/02 17:37:00 jpo Exp $
  * $DragonFly: src/usr.bin/xlint/lint1/err.c,v 1.6 2004/07/07 12:13:26 asmodai Exp $
  */
 
@@ -42,13 +42,14 @@
 
 #include <stdlib.h>
 #include <stdarg.h>
+#include <err.h>
 
 #include "lint1.h"
 
-static	const	char *basename(const char *);
+static	const	char *lbasename(const char *);
 static	void	verror(int, va_list);
 static	void	vwarning(int, va_list);
-
+static	void	excerpt(pos_t *);
 
 const	char *msgs[] = {
 	"syntax error: empty declaration",			      /* 0 */
@@ -182,8 +183,8 @@
 	"operands have incompatible pointer types, op %s",	      /* 128 */
 	"expression has null effect",				      /* 129 */
 	"enum type mismatch, op %s",				      /* 130 */
-	"conversion to '%s' may sign-extend incorrectly",	      /* 131 */
-	"conversion from '%s' may lose accuracy",		      /* 132 */
+	"conversion from '%s' to '%s' may sign-extend incorrectly",   /* 131 */
+	"converted from '%s' to '%s'",	                              /* 132 */
 	"conversion of pointer to '%s' loses bits",		      /* 133 */
 	"conversion of pointer to '%s' may lose bits",		      /* 134 */
 	"possible pointer alignment problem",			      /* 135 */
@@ -204,16 +205,16 @@
 	"argument mismatch: %d arg%s passed, %d expected",	      /* 150 */
 	"void expressions may not be arguments, arg #%d",	      /* 151 */
 	"argument cannot have unknown size, arg #%d",		      /* 152 */
-	"argument has incompatible pointer type, arg #%d",	      /* 153 */
-	"illegal combination of pointer and integer, arg #%d",	      /* 154 */
-	"argument is incompatible with prototype, arg #%d",	      /* 155 */
-	"enum type mismatch, arg #%d",			       	      /* 156 */
+	"%s() arg #%d: incompatible pointer type",		      /* 153 */
+	"%s() arg #%d: illegal combination of pointer and integer",   /* 154 */
+	"%s() arg #%d: argument is incompatible with prototype",      /* 155 */
+	"%s() arg #%d: enum type mismatch",			      /* 156 */
 	"ANSI C treats constant as unsigned",			      /* 157 */
-	"%s may be used before set",			      	      /* 158 */
+	"%s may be used before set",				      /* 158 */
 	"assignment in conditional context",			      /* 159 */
 	"operator '==' found where '=' was expected",		      /* 160 */
 	"constant in conditional context",			      /* 161 */
-	"comparision of %s with %s, op %s",			      /* 162 */
+	"comparison of %s with %s, op %s",			      /* 162 */
 	"a cast does not yield an lvalue",			      /* 163 */
 	"assignment of negative constant to unsigned type",	      /* 164 */
 	"constant truncated by assignment",			      /* 165 */
@@ -242,7 +243,7 @@
 	"no automatic aggregate initialization in traditional C",     /* 188 */
 	"assignment of struct/union illegal in traditional C",	      /* 189 */
 	"empty array declaration: %s",				      /* 190 */
-	"%s set but not used in function %s",		      	      /* 191 */
+	"%s set but not used in function %s",			      /* 191 */
 	"%s unused in function %s",				      /* 192 */
 	"statement not reached",				      /* 193 */
 	"label %s redefined",					      /* 194 */
@@ -281,9 +282,9 @@
 	"const object %s should have initializer",		      /* 227 */
 	"function cannot return const or volatile object",	      /* 228 */
 	"questionable conversion of function pointer",		      /* 229 */
-	"nonportable character comparision, op %s",		      /* 230 */
-	"argument %s unused in function %s",			      /* 231 */
-	"label %s unused in function %s",			      /* 232 */
+	"nonportable character comparison, op %s",		      /* 230 */
+	"argument %s unused in function %s()",			      /* 231 */
+	"label %s unused in function %s()",			      /* 232 */
 	"struct %s never defined",				      /* 233 */
 	"union %s never defined",				      /* 234 */
 	"enum %s never defined",				      /* 235 */
@@ -294,7 +295,7 @@
 	"assignment of different structures",			      /* 240 */
 	"dubious operation on enum, op %s",			      /* 241 */
 	"combination of '%s' and '%s', op %s",			      /* 242 */
-	"dubious comparision of enums, op %s",			      /* 243 */
+	"dubious comparison of enums, op %s",			      /* 243 */
 	"illegal structure pointer combination",		      /* 244 */
 	"illegal structure pointer combination, op %s",		      /* 245 */
 	"dubious conversion of enum to '%s'",			      /* 246 */
@@ -310,7 +311,7 @@
 	"unterminated comment",					      /* 256 */
 	"extra characters in lint comment",			      /* 257 */
 	"unterminated string constant",				      /* 258 */
-	"conversion to '%s' due to prototype, arg #%d",		      /* 259 */
+	"%s() arg #%d: converted from '%s' to '%s'",		      /* 259 */
 	"previous declaration of %s",				      /* 260 */
 	"previous definition of %s",				      /* 261 */
 	"\\\" inside character constants undefined in traditional C", /* 262 */
@@ -325,11 +326,11 @@
 	"switch expression must be of type `int' in traditional C",   /* 271 */
 	"empty translation unit",				      /* 272 */
 	"bit-field type '%s' invalid in ANSI C",		      /* 273 */
-	"ANSI C forbids comparision of %s with %s",		      /* 274 */
+	"ANSI C forbids comparison of %s with %s",		      /* 274 */
 	"cast discards 'const' from pointer target type",	      /* 275 */
 	"",							      /* 276 */
 	"initialisation of '%s' with '%s'",			      /* 277 */
-	"combination of '%s' and '%s', arg #%d",		      /* 278 */
+	"%s() arg #%d: combination of '%s' and '%s'",		      /* 278 */
 	"combination of '%s' and '%s' in return",		      /* 279 */
 	"must be outside function: /* %s */",			      /* 280 */
 	"duplicate use of /* %s */",				      /* 281 */
@@ -346,10 +347,10 @@
 	"cannot concatenate wide and regular string literals",	      /* 292 */
 	"argument %d must be 'char *' for PRINTFLIKE/SCANFLIKE",      /* 293 */
 	"multi-character character constant",			      /* 294 */
-	"conversion of '%s' to '%s' is out of range, arg #%d",	      /* 295 */
-	"conversion of negative constant to unsigned type, arg #%d",  /* 296 */
-	"conversion to '%s' may sign-extend incorrectly, arg #%d",    /* 297 */
-	"conversion from '%s' may lose accuracy, arg #%d",	      /* 298 */
+	"%s() arg #%d: conversion of '%s' to '%s' is out of range",   /* 295 */
+	"%s() arg #%d: conversion of negative constant to unsigned type",  /* 296 */
+	"%s() arg #%d: conversion from '%s' to '%s' may sign-extend incorrectly",    /* 297 */
+	"%s() arg #%d: converted from '%s' to '%s'",		      /* 298 */
 	"prototype does not match old style definition, arg #%d",     /* 299 */
 	"old style definition",					      /* 300 */
 	"array of incomplete type",				      /* 301 */
@@ -361,14 +362,19 @@
 	"static variable %s set but not used",			      /* 307 */
 	"",							      /* 308 */
 	"extra bits set to 0 in conversion of '%s' to '%s', op %s",   /* 309 */
+	"right shift of %d-bit quantity by %lld bits",		      /* 310 */
+	"case ranges are illegal in ANSI C",			      /* 311 */
+	"suspicious operator for sizeof: %s",			      /* 312 */
+	"conversion of %s() return value from '%s' to '%s'",	      /* 313 */
+	"hexadecimal float constants are illegal in traditional C",   /* 314 */
 };
 
 /*
- * If Fflag is not set basename() returns a pointer to the last
+ * If Fflag is not set lbasename() returns a pointer to the last
  * component of the path, otherwise it returns the argument.
  */
 static const char *
-basename(const char *path)
+lbasename(const char *path)
 {
 	const	char *cp, *cp1, *cp2;
 
@@ -390,11 +396,14 @@
 {
 	const	char *fn;
 
-	fn = basename(curr_pos.p_file);
+	fn = lbasename(curr_pos.p_file);
 	(void)printf("%s:%d: ", fn, curr_pos.p_line);
 	(void)vprintf(msgs[n], ap);
 	(void)printf("\n");
 	nerr++;
+
+	if (fflag)
+		excerpt(&curr_pos);
 }
 
 static void
@@ -406,10 +415,13 @@
 		/* this warning is suppressed by a LINTED comment */
 		return;
 
-	fn = basename(curr_pos.p_file);
+	fn = lbasename(curr_pos.p_file);
 	(void)printf("%s:%d: warning: ", fn, curr_pos.p_line);
 	(void)vprintf(msgs[n], ap);
 	(void)printf("\n");
+
+	if (fflag)
+		excerpt(&curr_pos);
 }
 
 void
@@ -429,7 +441,7 @@
 	const	char *fn;
 
 	va_start(ap, msg);
-	fn = basename(curr_pos.p_file);
+	fn = lbasename(curr_pos.p_file);
 	(void)fprintf(stderr, "%s:%d: lint error: ", fn, curr_pos.p_line);
 	(void)vfprintf(stderr, msg, ap);
 	(void)fprintf(stderr, "\n");
@@ -454,11 +466,14 @@
 	const	char *fn;
 
 	va_start(ap, n);
-	fn = basename(curr_pos.p_file);
+	fn = lbasename(curr_pos.p_file);
 	(void)printf("%s:%d: ", fn, curr_pos.p_line);
 	(void)vprintf(msgs[n], ap);
 	(void)printf("\n");
 	va_end(ap);
+
+	if (fflag)
+		excerpt(&curr_pos);
 }
 
 int
@@ -481,3 +496,51 @@
 
 	return (msg);
 }
+
+static void
+excerpt(pos_t *pos)
+{
+	static	FILE *fp = NULL;
+	static	const char *file = NULL;
+	static	int lineno = 0;
+	char	*buf, *lbuf;
+	size_t	len;
+
+	if (!pos || !pos->p_file)
+		return;
+
+	/* don't print the same line twice */
+	if (pos->p_line == lineno)
+		return;
+
+	if (fp == NULL || file != pos->p_file || pos->p_line < lineno) {
+		if (fp)
+			fclose(fp);
+
+		if (!(fp = fopen(pos->p_file, "r")))
+			return;
+
+		file = pos->p_file;
+		lineno = 0;
+	}
+
+	lbuf = NULL;
+	while (lineno < pos->p_line && (buf = fgetln(fp, &len))) {
+		if (buf[len - 1] == '\n')
+			buf[len - 1] = '\0';
+		else {
+			/* EOF without EOL, copy and add the NUL */
+			if (!(lbuf = malloc(len + 1)))
+				err(1, NULL);
+
+			lbuf[len] = '\0';
+			buf = lbuf;
+		}
+		lineno++;
+	}
+
+	if (buf)
+		printf("%s:%d:   %s\n", pos->p_file, lineno, buf);
+
+	free(lbuf);
+}
Index: usr.bin/xlint/lint1/externs.h
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/externs.h,v
retrieving revision 1.3
diff -u -r1.3 externs.h
--- usr.bin/xlint/lint1/externs.h	3 Nov 2003 19:31:34 -0000	1.3
+++ usr.bin/xlint/lint1/externs.h	25 Dec 2006 10:06:05 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: externs.h,v 1.4 2006/03/08 07:18:51 moritz Exp $	*/
 /*	$NetBSD: externs.h,v 1.2 1995/07/03 21:24:06 cgd Exp $	*/
 
 /*
@@ -40,7 +41,6 @@
 extern	void	*xcalloc(size_t, size_t);
 extern	void	*xrealloc(void *, size_t);
 extern	char	*xstrdup(const char *);
-extern	void	nomem(void);
 
 /*
  * emit.c
Index: usr.bin/xlint/lint1/externs1.h
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/externs1.h,v
retrieving revision 1.3
diff -u -r1.3 externs1.h
--- usr.bin/xlint/lint1/externs1.h	3 Nov 2003 19:31:34 -0000	1.3
+++ usr.bin/xlint/lint1/externs1.h	25 Dec 2006 10:06:57 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: externs1.h,v 1.15 2006/05/29 20:47:22 cloder Exp $	*/
 /*	$NetBSD: externs1.h,v 1.7 1995/10/02 17:31:39 jpo Exp $	*/
 
 /*
@@ -37,18 +38,16 @@
 /*
  * main.c
  */
-extern	int	aflag;
-extern	int	bflag;
 extern	int	cflag;
 extern	int	dflag;
 extern	int	eflag;
+extern	int	fflag;
 extern	int	Fflag;
 extern	int	gflag;
 extern	int	hflag;
 extern	int	pflag;
 extern	int	rflag;
 extern	int	sflag;
-extern	int	tflag;
 extern	int	uflag;
 extern	int	vflag;
 extern	int	yflag;
@@ -120,7 +119,7 @@
 extern	void	warning(int, ...);
 extern	void	message(int, ...);
 extern	int	gnuism(int, ...);
-extern	void	lerror(const char *, ...) __printflike(1, 2);
+extern	void	lerror(const char *, ...);
 
 /*
  * decl.c
@@ -191,12 +190,13 @@
 extern	sym_t	*strmemb(tnode_t *, op_t, sym_t *);
 extern	tnode_t	*build(op_t, tnode_t *, tnode_t *);
 extern	tnode_t	*cconv(tnode_t *);
-extern	int	typeok(op_t, int, tnode_t *, tnode_t *);
+extern	int	typeok(op_t, farg_t *, tnode_t *, tnode_t *);
 extern	tnode_t	*promote(op_t, int, tnode_t *);
-extern	tnode_t	*convert(op_t, int, type_t *, tnode_t *);
-extern	void	cvtcon(op_t, int, type_t *, val_t *, val_t *);
+extern	tnode_t	*convert(op_t, farg_t *, type_t *, tnode_t *);
+extern	void	cvtcon(op_t, farg_t *, type_t *, val_t *, val_t *);
 extern	const	char *tyname(type_t *);
 extern	tnode_t	*bldszof(type_t *);
+extern	tnode_t	*bldszoftrm(tnode_t *);
 extern	tnode_t	*cast(tnode_t *, type_t *);
 extern	tnode_t	*funcarg(tnode_t *, tnode_t *);
 extern	tnode_t	*funccall(tnode_t *, tnode_t *);
@@ -205,6 +205,7 @@
 extern	void	chkmisc(tnode_t *, int, int, int, int, int, int);
 extern	int	conaddr(tnode_t *, sym_t **, ptrdiff_t *);
 extern	strg_t	*catstrg(strg_t *, strg_t *);
+extern	void	displexpr(tnode_t *, int);
 
 /*
  * func.c
@@ -224,6 +225,8 @@
 extern	int	ccflg;
 extern	int	llibflg;
 extern	int	nowarn;
+extern	int	noretflg;
+extern	int	usedflg;
 extern	int	plibflg;
 extern	int	quadflg;
 
@@ -250,6 +253,8 @@
 extern	void	doreturn(tnode_t *);
 extern	void	glclup(int);
 extern	void	argsused(int);
+extern	void	noreturn(int);
+extern	void	lintused(int);
 extern	void	constcond(int);
 extern	void	fallthru(int);
 extern	void	notreach(int);
Index: usr.bin/xlint/lint1/func.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/func.c,v
retrieving revision 1.3
diff -u -r1.3 func.c
--- usr.bin/xlint/lint1/func.c	7 Jul 2004 12:13:26 -0000	1.3
+++ usr.bin/xlint/lint1/func.c	25 Dec 2006 10:07:59 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: func.c,v 1.18 2006/05/29 20:47:22 cloder Exp $	*/
 /*	$NetBSD: func.c,v 1.7 1995/10/02 17:31:40 jpo Exp $	*/
 
 /*
@@ -55,7 +56,7 @@
 int	rchflg;
 
 /*
- * In conjunction with reached ontrols printing of "fallthrough on ..."
+ * In conjunction with reached controls printing of "fallthrough on ..."
  * warnings.
  * Reset by each statement and set by FALLTHROUGH, switch (switch1())
  * and case (label()).
@@ -81,6 +82,18 @@
 pos_t	aupos;
 
 /*
+ * If the following function has been declared NORETURN, noretflg is set
+ * to 1. Otherwise it is set to 0.
+ */
+int	noretflg = 0;
+
+/*
+ * If the following symbol should be marked as having been used, even if
+ * lint thinks otherwise, usedflg is set to 1. Otherwise it is set to 0.
+ */
+int	usedflg = 0;
+
+/*
  * Number of arguments of the following function definition whose types
  * shall be checked by lint2. -1 stands for all arguments.
  *
@@ -103,13 +116,13 @@
 pos_t	scflpos;
 
 /*
- * Are both plibflg and llibflg set, prototypes are writen as function
+ * Are both plibflg and llibflg set, prototypes are written as function
  * definitions to the output file.
  */
 int	plibflg;
 
 /*
- * Nonzero means that no warnings about constands in conditional
+ * Nonzero means that no warnings about constants in conditional
  * context are printed.
  */
 int	ccflg;
@@ -130,7 +143,7 @@
  * Nonzero if complaints about use of "long long" are suppressed in
  * the next statement or declaration.
  */
-int	quadflg;
+int	quadflg = 1;
 
 /*
  * Puts a new element at the top of the stack used for control statements.
@@ -188,7 +201,7 @@
  * Called after a function declaration which introduces a function definition
  * and before an (optional) old style argument declaration list.
  *
- * Puts all symbols declared in the Prototype or in an old style argument
+ * Puts all symbols declared in the prototype or in an old style argument
  * list back to the symbol table.
  *
  * Does the usual checking of storage class, type (return value),
@@ -215,6 +228,26 @@
 	}
 
 	/*
+	 * __func__ is a "predefined identifier" in c99, which means it is a
+	 * block-scope variable supplying the name of the enclosing function.
+	 * It is defined as:
+	 *
+	 * static const char __func__[] = "function-name";
+	 *
+	 */
+	sym = getblk(sizeof (sym_t));
+	sym->s_name = "__func__";
+	sym->s_kind = FVFT;
+	sym->s_scl = STATIC;
+	sym->s_type = incref(gettyp(CHAR), ARRAY);
+	sym->s_blklev = 1;
+	sym->s_def = DEF;
+	sym->s_type->t_dim = strlen(fsym->s_name) + 1;
+	sym->s_type->t_subt = duptyp(gettyp(CHAR));
+	sym->s_type->t_subt->t_const = 1;
+	inssym(1, sym);
+
+	/*
 	 * In osfunc() we did not know whether it is an old style function
 	 * definition or only an old style declaration, if there are no
 	 * arguments inside the argument list ("f()").
@@ -317,7 +350,7 @@
 	}
 
 	if (dcs->d_notyp)
-		/* return value is implizitly declared to be int */
+		/* return value is implicitly declared to be int */
 		fsym->s_rimpl = 1;
 
 	reached = 1;
@@ -342,7 +375,7 @@
 	}
 
 	/*
-	 * This warning is printed only if the return value was implizitly
+	 * This warning is printed only if the return value was implicitly
 	 * declared to be int. Otherwise the wrong return statement
 	 * has already printed a warning.
 	 */
@@ -360,10 +393,14 @@
 	}
 	nargusg = -1;
 
+	if (noretflg)
+		funcsym->s_noreturn = 1;
+	noretflg = 0;
+
 	/*
 	 * write the information about the function definition to the
 	 * output file
-	 * inline functions explicitely declared extern are written as
+	 * inline functions explicitly declared extern are written as
 	 * declarations only.
 	 */
 	if (dcs->d_scl == EXTERN && funcsym->s_inline) {
@@ -442,12 +479,6 @@
 			}
 
 			t = tn->tn_type->t_tspec;
-			if (t == LONG || t == ULONG ||
-			    t == QUAD || t == UQUAD) {
-				if (tflag)
-					/* case label must be of type ... */
-					warning(203);
-			}
 
 			/*
 			 * get the value of the expression and convert it
@@ -455,7 +486,7 @@
 			 */
 			v = constant(tn);
 			nv = xcalloc(1, sizeof (val_t));
-			cvtcon(CASE, 0, ci->c_swtype, nv, v);
+			cvtcon(CASE, NULL, ci->c_swtype, nv, v);
 			free(v);
 
 			/* look if we had this value already */
@@ -565,13 +596,6 @@
 		error(205);
 		tn = NULL;
 	}
-	if (tn != NULL && tflag) {
-		t = tn->tn_type->t_tspec;
-		if (t == LONG || t == ULONG || t == QUAD || t == UQUAD) {
-			/* switch expr. must be of type `int' in trad. C */
-			warning(271);
-		}
-	}
 
 	/*
 	 * Remember the type of the expression. Because its possible
@@ -903,7 +927,17 @@
 			ci->c_break = 1;
 	}
 
-	if (bflag)
+	/* Don't warn about unreachable breaks in a switch, e.g.:
+	 *
+	 * switch (foo) {
+	 * case 1:
+	 *     return 1;
+	 *     break;
+	 * case 2:
+	 *     // etc...
+	 * }
+	 */
+	if (ci == NULL || !ci->c_switch)
 		chkreach();
 
 	reached = rchflg = 0;
@@ -1074,6 +1108,29 @@
 }
 
 /*
+ * NORETURN comment
+ *
+ * The following function will never return, which means any code
+ * following a call to this function is unreachable.
+ */
+void
+noreturn(int n)
+{
+	noretflg = 1;
+}
+
+/*
+ * LINTUSED comment
+ *
+ * Mark a symbol as used, so lint2 does not complain.
+ */
+void
+lintused(int n)
+{
+	usedflg = 1;
+}
+
+/*
  * VARARGS comment
  *
  * Makes that lint2 checks only the first n arguments for compatibility
Index: usr.bin/xlint/lint1/init.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/init.c,v
retrieving revision 1.6
diff -u -r1.6 init.c
--- usr.bin/xlint/lint1/init.c	7 Jul 2004 12:24:00 -0000	1.6
+++ usr.bin/xlint/lint1/init.c	25 Dec 2006 10:10:02 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: init.c,v 1.10 2006/05/29 20:47:22 cloder Exp $	*/
 /*	$NetBSD: init.c,v 1.4 1995/10/02 17:21:37 jpo Exp $	*/
 
 /*
@@ -30,7 +31,6 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
- * $NetBSD: init.c,v 1.4 1995/10/02 17:21:37 jpo Exp $
  * $DragonFly: src/usr.bin/xlint/lint1/init.c,v 1.6 2004/07/07 12:24:00 asmodai Exp $
  */
 
@@ -39,7 +39,7 @@
 #include "lint1.h"
 
 /*
- * initerr is set as soon as a fatal error occured in an initialisation.
+ * initerr is set as soon as a fatal error occurred in an initialisation.
  * The effect is that the rest of the initialisation is ignored (parsed
  * by yacc, expression trees built, but no initialisation takes place).
  */
@@ -198,9 +198,6 @@
 		istk->i_cnt = istk->i_type->t_dim;
 		break;
 	case UNION:
-		if (tflag)
-			/* initialisation of union is illegal in trad. C */
-			warning(238);
 		/* FALLTHROUGH */
 	case STRUCT:
 		if (incompl(istk->i_type)) {
@@ -305,13 +302,6 @@
 	if (initerr)
 		return;
 
-	if ((initsym->s_scl == AUTO || initsym->s_scl == REG) &&
-	    initstk->i_nxt == NULL) {
-		if (tflag && !issclt(initstk->i_subt->t_tspec))
-			/* no automatic aggregate initialization in trad. C*/
-			warning(188);
-	}
-
 	/*
 	 * Remove all entries which cannot be used for further initializers
 	 * and do not expect a closing brace.
@@ -346,7 +336,7 @@
 	sc = initsym->s_scl;
 
 	/*
-	 * Do not test for automatic aggregat initialisation. If the
+	 * Do not test for automatic aggregate initialisation. If the
 	 * initalizer starts with a brace we have the warning already.
 	 * If not, an error will be printed that the initializer must
 	 * be enclosed by braces.
@@ -398,7 +388,7 @@
 	if (!issclt(lt))
 		lerror("mkinit() 1");
 
-	if (!typeok(INIT, 0, ln, tn))
+	if (!typeok(INIT, NULL, ln, tn))
 		goto end;
 
 	/*
@@ -409,18 +399,8 @@
 	expr(tn, 1, 0);
 	trestor(tmem);
 
-	if (isityp(lt) && ln->tn_type->t_isfield && !isityp(rt)) {
-		/*
-		 * Bit-fields can be initialized in trad. C only by integer
-		 * constants.
-		 */
-		if (tflag)
-			/* bit-field initialisation is illegal in trad. C */
-			warning(186);
-	}
-
 	if (lt != rt || (initstk->i_type->t_isfield && tn->tn_op == CON))
-		tn = convert(INIT, 0, initstk->i_type, tn);
+		tn = convert(INIT, NULL, initstk->i_type, tn);
 
 	if (tn != NULL && tn->tn_op != CON) {
 		sym = NULL;
@@ -459,7 +439,7 @@
 	 * Check if we have an array type which can be initialized by
 	 * the string.
 	 */
-	if (istk->i_subt->t_tspec == ARRAY) {
+	if (istk->i_subt != NULL && istk->i_subt->t_tspec == ARRAY) {
 		t = istk->i_subt->t_subt->t_tspec;
 		if (!((strg->st_tspec == CHAR &&
 		       (t == CHAR || t == UCHAR || t == SCHAR)) ||
Index: usr.bin/xlint/lint1/lint.h
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/lint.h,v
retrieving revision 1.1
diff -u -r1.1 lint.h
--- usr.bin/xlint/lint1/lint.h	17 Jun 2003 02:56:38 -0000	1.1
+++ usr.bin/xlint/lint1/lint.h	25 Dec 2006 10:11:07 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: lint.h,v 1.6 2006/05/29 20:47:22 cloder Exp $	*/
 /*	$NetBSD: lint.h,v 1.2 1995/07/03 21:24:18 cgd Exp $	*/
 
 /*
@@ -29,6 +30,8 @@
  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ * $DragonFly$
  */
 
 #include <sys/types.h>
@@ -38,7 +41,7 @@
 #include "param.h"
 
 /*
- * Type specifiers, used in type structures (type_t) and otherwere.
+ * Type specifiers, used in type structures (type_t) and elsewhere.
  */
 typedef enum {
 	NOTSPEC,
@@ -56,7 +59,7 @@
 	QUAD,		/* (signed) long long */
 	UQUAD,		/* unsigned long long */
 	FLOAT,		/* float */
-	DOUBLE,		/* double or, with tflag, long float */
+	DOUBLE,		/* double */
 	LDOUBLE,	/* long double */
 	VOID,		/* void */
 	STRUCT,		/* structure tag */
@@ -75,6 +78,7 @@
 	int	tt_sz;			/* size in bits */
 	int	tt_psz;			/* size, different from tt_sz
 					   if pflag is set */
+	int	tt_rank;		/* rank (C99), similar to tt_psz */
 	tspec_t	tt_styp;		/* signed counterpart */
 	tspec_t	tt_utyp;		/* unsigned counterpart */
 	u_int	tt_isityp : 1;		/* 1 if integer type */
@@ -82,11 +86,12 @@
 	u_int	tt_isftyp : 1;		/* 1 if floating point type */
 	u_int	tt_isatyp : 1;		/* 1 if arithmetic type */
 	u_int	tt_issclt : 1;		/* 1 if scalar type */
-	char	*tt_name;		/* Bezeichnung des Typs */
+	char	*tt_name;		/* type name */
 } ttab_t;
 
 #define size(t)		(ttab[t].tt_sz)
 #define psize(t)	(ttab[t].tt_psz)
+#define rank(t)		(ttab[t].tt_rank)
 #define styp(t)		(ttab[t].tt_styp)
 #define utyp(t)		(ttab[t].tt_utyp)
 #define isityp(t)	(ttab[t].tt_isityp)
Index: usr.bin/xlint/lint1/lint1.h
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/lint1.h,v
retrieving revision 1.1
diff -u -r1.1 lint1.h
--- usr.bin/xlint/lint1/lint1.h	17 Jun 2003 02:56:38 -0000	1.1
+++ usr.bin/xlint/lint1/lint1.h	25 Dec 2006 10:12:18 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: lint1.h,v 1.13 2006/04/18 02:59:40 cloder Exp $	*/
 /*	$NetBSD: lint1.h,v 1.6 1995/10/02 17:31:41 jpo Exp $	*/
 
 /*
@@ -29,6 +30,8 @@
  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ * $DragonFly$
  */
 
 #include "lint.h"
@@ -65,7 +68,7 @@
  * qualifiers (only for lex/yacc interface)
  */
 typedef enum {
-	CONST, VOLATILE
+	CONST, VOLATILE, RESTRICT
 } tqual_t;
 
 /*
@@ -75,6 +78,7 @@
 	tspec_t	v_tspec;
 	int	v_ansiu;		/* set if an integer constant is
 					   unsigned in ANSI C */
+	tspec_t	v_lspec;		/* the underlying type of a literal */
 	union {
 		quad_t	_v_quad;	/* integers */
 		ldbl_t	_v_ldbl;	/* floats */
@@ -88,7 +92,7 @@
  * Structures of type str_t uniqely identify structures. This can't
  * be done in structures of type type_t, because these are copied
  * if they must be modified. So it would not be possible to check
- * if to structures are identical by comparing the pointers to
+ * if two structures are identical by comparing the pointers to
  * the type structures.
  *
  * The typename is used if the structure is unnamed to identify
@@ -122,6 +126,7 @@
 	u_int	t_aincompl : 1;	/* incomplete array type */
 	u_int	t_const : 1;	/* const modifier */
 	u_int	t_volatile : 1;	/* volatile modifier */
+	u_int	t_restrict : 1;	/* restrict modifier */
 	u_int	t_proto : 1;	/* function prototype (t_args valid) */
 	u_int	t_vararg : 1;	/* protoype with ... */
 	u_int	t_typedef : 1;	/* type defined with typedef */
@@ -202,9 +207,10 @@
 	u_int	s_reg : 1;	/* symbol is register variable */
 	u_int	s_defarg : 1;	/* undefined symbol in old style function
 				   definition */
-	u_int	s_rimpl : 1;	/* return value of function implizit decl. */
+	u_int	s_rimpl : 1;	/* return value of function implicit decl. */
 	u_int	s_osdef : 1;	/* symbol stems from old style function def. */
 	u_int	s_inline : 1;	/* true if this is a inline function */
+	u_int	s_noreturn : 1;	/* true if this is a NORETURN function */
 	struct	sym *s_xsym;	/* for local declared external symbols pointer
 				   to external symbol with same name */
 	def_t	s_def;		/* declared, tentative defined, defined */
@@ -225,7 +231,7 @@
 	struct	sym **s_rlink;	/* pointer to s_link of prev. symbol */
 	struct	sym *s_nxt;	/* next struct/union member, enumerator,
 				   argument */
-	struct	sym *s_dlnxt; 	/* next symbol declared on same level */
+	struct	sym *s_dlnxt;	/* next symbol declared on same level */
 } sym_t;
 
 #define	s_styp	u._s_st
@@ -254,7 +260,7 @@
 	op_t	tn_op;		/* operator */
 	type_t	*tn_type;	/* type */
 	u_int	tn_lvalue : 1;	/* node is lvalue */
-	u_int	tn_cast : 1;	/* if tn_op == CVT its an explizit cast */
+	u_int	tn_cast : 1;	/* if tn_op == CVT its an explicit cast */
 	u_int	tn_parn : 1;	/* node parenthesized */
 	union {
 		struct {
@@ -302,6 +308,7 @@
 	scl_t	d_ctx;		/* context of declaration */
 	u_int	d_const : 1;	/* const in declaration specifiers */
 	u_int	d_volatile : 1;	/* volatile in declaration specifiers */
+	u_int	d_restrict : 1;	/* restrict in declaration specifiers */
 	u_int	d_inline : 1;	/* inline in declaration specifiers */
 	u_int	d_mscl : 1;	/* multiple storage classes */
 	u_int	d_terr : 1;	/* invalid type combination */
@@ -341,6 +348,7 @@
 	int	p_pcnt;			/* number of asterisks */
 	u_int	p_const : 1;
 	u_int	p_volatile : 1;
+	u_int	p_restrict : 1;
 	struct	pqinf *p_nxt;
 } pqinf_t;
 
@@ -377,4 +385,14 @@
 	struct	cstk *c_nxt;		/* outer control statement */
 } cstk_t;
 
+/*
+ * Used to keep information about arguments passed to functions with
+ * prototypes.
+ */
+typedef struct farg {
+	int	fa_num;			/* argument number (1-basde) */
+	sym_t	*fa_sym;		/* argument symbol */
+	tnode_t	*fa_func;		/* function name */
+} farg_t;
+
 #include "externs1.h"
Index: usr.bin/xlint/lint1/main1.c
===================================================================
RCS file: /home/dcvs/src/usr.bin/xlint/lint1/main1.c,v
retrieving revision 1.6
diff -u -r1.6 main1.c
--- usr.bin/xlint/lint1/main1.c	7 Jul 2004 12:24:00 -0000	1.6
+++ usr.bin/xlint/lint1/main1.c	25 Dec 2006 10:14:15 -0000
@@ -1,3 +1,4 @@
+/*	$OpenBSD: main1.c,v 1.11 2006/05/29 20:47:22 cloder Exp $	*/
 /*	$NetBSD: main1.c,v 1.3 1995/10/02 17:29:56 jpo Exp $	*/
 
 /*
@@ -30,7 +31,6 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
- * $NetBSD: main1.c,v 1.3 1995/10/02 17:29:56 jpo Exp $
  * $DragonFly: src/usr.bin/xlint/lint1/main1.c,v 1.6 2004/07/07 12:24:00 asmodai Exp $
  */
 
@@ -44,17 +44,6 @@
 /* set yydebug to 1*/
 int	yflag;
 
-/*
- * Print warnings if an assignment of an integertype to another integertype
- * causes an implizit narrowing conversion. If aflag is 1, these warnings
- * are printed only if the source type is at least as wide as long. If aflag
- * is greather then 1, they are always printed.
- */
-int	aflag;
-
-/* Print a warning if a break statement cannot be reached. */
-int	bflag;
-
 /* Print warnings for pointer casts. */
 int	cflag;
 
@@ -65,7 +54,10 @@
 int	eflag;
 
 /* Print complete pathnames, not only the basename. */
-int	Fflag;
+int	Fflag = 1;
+
+/* After an error or warning, print the actual text of the program source code */
+int	fflag = 0;
 
 /* Enable some extensions of gcc */
 int	gflag;
@@ -88,9 +80,6 @@
 /* Strict ANSI C mode. */
 int	sflag;
 
-/* Traditional C mode. */
-int	tflag;
-
 /*
  * Complain about functions and external variables used and not defined,
  * or defined and not used.
@@ -101,7 +90,7 @@
 int	vflag = 1;
 
 /* Complain about structures which are never defined. */
-int	zflag = 1;
+int	zflag = 0;
 
 static	void	usage(void);
 
@@ -110,20 +99,21 @@
 {
 	int	c;
 
-	while ((c = getopt(argc, argv, "abcdeghprstuvyzF")) != -1) {
+	while ((c = getopt(argc, argv, "abcdefghprstuvyzF")) != -1) {
 		switch (c) {
-		case 'a':	aflag++;	break;
-		case 'b':	bflag = 1;	break;
+		case 'a':	/* obsolete */	break;
+		case 'b':	/* obsolete */	break;
 		case 'c':	cflag = 1;	break;
 		case 'd':	dflag = 1;	break;
 		case 'e':	eflag = 1;	break;
 		case 'F':	Fflag = 1;	break;
 		case 'g':	gflag = 1;	break;
 		case 'h':	hflag = 1;	break;
+		case 'f':	fflag = 1;	break;
 		case 'p':	pflag = 1;	break;
 		case 'r':	rflag = 1;	break;
 		case 's':	sflag = 1;	break;
-		case 't':	tflag = 1;	break;
+		case 't':	/* obsolete */	break;
 		case 'u':	uflag = 0;	break;
 		case 'v':	vflag = 0;	break;
 		case 'y':	yflag = 1;	break;
@@ -144,8 +134,10 @@
 	/* initialize output */
 	outopen(argv[1]);
 
+#if YYDEBUG
 	if (yflag)
 		yydebug = 1;
+#endif
 
 	initmem();
 	initdecl();
